#include <bits/stdc++.h>
using namespace std;
void unos(vector<long int> &d, vector<int> &p, int n)
{
    for(int i=0;i<n;i++)
    {
        cin >> d[i];
        cin >> p[i];
    }
}
void pitanja(vector<long int> &k, int q)
{
    for(int i=0;i<q;i++)
    {
        cin >> k[i];
    }
}
int main()
{
    int n, q;
    cin >> n;
    cin >> q;
    vector<int> p(n);
    vector<long int> d(n), k(q);
    unos(d, p, n);
    pitanja(k, q);
    for(int i=0;i<q;i++)
    {
        long int dan=k[i], b=0, stek=0, prati_dan=0;
        for(int j=0;j<n;j++)
        {
            if(d[j]>=dan)
            {
                j=n;
                break;
            }
            if(stek==0)
            {
                if(prati_dan<d[j])
                    prati_dan=d[j]-1;
                stek+=p[j];
            }
            else
            {
                if(prati_dan<d[j])
                    prati_dan=d[j]-prati_dan-1;
                stek+=p[j];
            }
            if(prati_dan<dan)
            {
                if(dan-prati_dan>0 && stek>=dan-prati_dan )
                {
                    b+=dan-prati_dan;
                    stek-=dan-prati_dan;
                    prati_dan+=dan-prati_dan;
                }
                else if(dan-prati_dan>0 && stek<dan-prati_dan)
                {
                    b+=stek;
                    prati_dan+=stek;
                    stek=0;
                }
            }
        }
        cout << b << endl;
    }
    return 0;
}